// callerid.c - listen for SIP INVITE packets and send to mythnotify
//
// Copyright (c) 2007 David George. ALL RIGHTS RESERVED.
//////////////////////////////////////////////////////////////////////////////

/****************************************************************************
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version.
 *
 * You should have received a copy of this license with this source
 * code.  If you haven't you can view a copy at:
 *
 * http://www.gnu.org/licenses/gpl.txt
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 ****************************************************************************/

#include "mythmon.h"

// dev=eth0
// filter=udp port 5060
// snaplen=50000
// timeout=1000

int callerid(char *device, char *filter, int snaplen, int promisc, int timeout)
{
  pcap_t pcapdesc;
  struct bpf_program filtbuff;
  struct pcap_pkthdr pkthdr;
  char filtbuff[81], errbuff[PCAP_ERRBUF_SIZE];
  const u_char *packet;

  // FIXME - errno probably isn't the right thing to use

  if ((pcapdesc = pcap_open_live(device, snaplen, promisc, timeout, errbuff)) {
    syslog(LOG_ERR, "callerid: pcap_open_live() err=%d\n", errno);
    return(-1);
  }

  pcap_compile(pcapdesc, &filtbuff, filter, 0, 0);
  pcap_setfilter(pcapdesc, &filtbuff);

  // FIXME - add loop

  if ((packet = pcap_next(pcapdesc, &pkthdr)) == NULL) {
    syslog(LOG_ERR, "callerid: pcap_next() err=%d\n", errno);
    pcap_close(pcapdesc);
    return(-1);
  }

  pcap_close(pcapdesc);

  return(0);
}
